From 3f575419e7ccb37a3b10ecc82adb2e83ff2826e1 Mon Sep 17 00:00:00 2001
From: Takuro Ashie <ashie@clear-code.com>
Date: Thu, 17 Dec 2020 15:35:13 +0900
Subject: [PATCH] Fix broken "-t" option of collectd

"-t" option should test config file but it always returns 0 with no
message even if a broken config file is specified.

Signed-off-by: Takuro Ashie <ashie@clear-code.com>
---
 src/daemon/collectd.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

diff --git a/src/daemon/collectd.c b/src/daemon/collectd.c
index 2de0e1b104..cad82d4d5a 100644
--- a/src/daemon/collectd.c
+++ b/src/daemon/collectd.c
@@ -395,9 +395,6 @@ struct cmdline_config init_config(int argc, char **argv) {
 
   read_cmdline(argc, argv, &config);
 
-  if (config.test_config)
-    exit(EXIT_SUCCESS);
-
   if (optind < argc)
     exit_usage(EXIT_FAILURE);
 
@@ -406,6 +403,9 @@ struct cmdline_config init_config(int argc, char **argv) {
   if (configure_collectd(&config) != 0)
     exit(EXIT_FAILURE);
 
+  if (config.test_config)
+    exit(EXIT_SUCCESS);
+
   return config;
 }
 
